/*
 * Copyright (c) 2001-2005 Servertec. All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * THIS NOTICE MUST NOT BE ALTERED NOR REMOVED.
 *
 * CopyrightVersion 1.0
 */

import stec.sfc.Win32.Console;
import stec.sfc.Win32.FileSystem;
import stec.sfc.Win32.FileSystemChangeEvent;
import stec.sfc.Win32.FileSystemChangeListener;
import stec.sfc.Win32.FileSystemChangeNotification;
import stec.sfc.Win32.FileSystemChangeHandler;

public class monitor implements FileSystemChangeHandler
{
	static String path;
	static monitor change_handler = new monitor();

	FileSystemChangeListener change_listener;

	public static void main(String[] args) throws Exception
	{
		if(args.length < 1)
		{
			path = FileSystem.getCurrentDirectory();
		}
		else
		{
			path = args[0];
		}

		FileSystemChangeNotification change_notification = new FileSystemChangeNotification(path, false, FileSystemChangeEvent.ATTRIBUTES | FileSystemChangeEvent.DIRECTORY_NAME | FileSystemChangeEvent.FILE_NAME | FileSystemChangeEvent.LAST_WRITE_TIME, change_handler);

		change_handler.change_listener = new FileSystemChangeListener(change_notification);

		System.out.println("Monitoring...");

		System.out.println("Press Enter to exit.");

		while(true)
		{
			if(System.in.read() != -1)
			{
				stop();
			}

			try
			{
				Thread.sleep(100);
			}
			catch(InterruptedException ex)
			{
				stop();
			}
		}
	}

	public void fileSystemChanged(FileSystemChangeNotification change_notification)
	{
		System.out.println("file system changed");
	}

	private static void stop()
	{
		change_handler.change_listener.stop();
		System.exit(0);
	}
}